<?php

namespace Luticate\Utils;

use Laravel\Lumen\Routing\Controller as BaseController;

class LuController extends BaseController
{
    public static $parameters = null;

    function execute($businessClass, $businessMethod)
    {
        $params = app('request')->route()[2];
        self::$parameters = array_merge($_GET, $_POST, $params);
        $business = new $businessClass();

        $reflect = new \ReflectionMethod($businessClass, $businessMethod);
        $params = $reflect->getParameters();

        $args = array();
        foreach ($params as $param) {
            if ($param->isOptional()) {
                $args[$param->getName()] = LuBusiness::getParam($param->getName(), $param->getDefaultValue());
            }
            else {
                $args[$param->getName()] = LuBusiness::checkParam($param->getName());
            }
        }

        return LuOutputFormatter::formatSuccess(call_user_func_array(array($business, $businessMethod), $args));
    }
}
